/* Datei lager.c */
#include <stdio.h>
#include <stdlib.h>

unsigned int anzahlArtikel(char * dateiName);
void transferInDollar(char * dateiNameIn, char * dateiNameOut);

int main (void) 
{
	char * dateiNameIn = "lager.lst";
	char * dateiNameOut = "lager_dollar.lst";
	unsigned int anz = anzahlArtikel(dateiNameIn);
	printf("In der Datei %s befinden sich %d Artikel\n", dateiNameIn, anz);
	transferInDollar(dateiNameIn, dateiNameOut);
	return 0;
}

unsigned int anzahlArtikel(char * dateiName)
{
	FILE * fin;
	int ret = 0;

	fin = fopen(dateiName, "rt");
	if (!fin)
	{
		fprintf(stderr, "Kann Datei %s nicht zum Lesen oeffnen. Abbruch.",
			dateiName );
		exit(-1);
	}
	while ( !feof(fin) )
		if (fgetc(fin) == '\n')
			ret++;
	fclose(fin);
	return ret;
}

void transferInDollar(char * dateiNameIn, char * dateiNameOut)
{
	FILE * fin, * fout;
	float euro2dollar;

	fin = fopen(dateiNameIn, "rt");
	if(!fin)
	{
		fprintf(stderr, "Kann Datei %s nicht zum Lesen oeffnen. Abbruch.",	dateiNameIn );
		exit(-2);
	}

	fout = fopen(dateiNameOut, "wt");
	if(!fout) 
	{
		fprintf(stderr, "Kann Datei %s nicht zum Schreiben oeffnen. Abbruch.", dateiNameOut );
		exit(-2);
	}

	printf ("Umrechnungsfaktor Euro in Dollar: ");
	scanf ("%f", &euro2dollar);

	while( !feof(fin) )
	{
		unsigned int nr, anz;
		double gew, preis;
		fscanf(fin, "%d;%d;%lg;%lg\n", &nr, &anz, &gew, &preis );
		preis /= euro2dollar;
		fprintf(fout, "%8d;%8d;%10.3f;%10.2f\n", nr, anz, gew, preis);
	} 
	fclose(fin);
	fclose(fout);
}
