/* Datei: stack.h */
#ifndef _STACK_H_
#define _STACK_H_
enum stack_errors { 
   STACK_OK,/* Kennnummer fuer korrekt abgelaufene Stack-Operation*/
   STACK_VOLL,                    /* Kennnummer fuer vollen Stack */
   STACK_LEER                     /* Kennnummer fuer leeren Stack */  
};

/* Extern-Deklarationen der exportierten Funktionen:              */

/* Eine int-Zahl auf den Stack legen.                             */
/* Parameter: int-Zahl, die auf den Stack soll.                   */
/* Return: Fehlercode.                                            */
extern enum stack_errors stack_push (const int);      

/* Eine int-Zahl vom Stack abholen.                               */
/* Parameter: Pointer auf int-Zahl, die mit dem obersten          */
/*            Stack-Wert gefuellt wird.                           */
/* Return: Fehlercode.                                            */
extern enum stack_errors stack_pop (int * const); 

/* Anzahl der Elemente auf dem Stack abholen.                     */
/* Return: Anzahl.                                                */
extern int stack_num (); 
#endif
