/* Datei: stack.c */
#include <stdio.h>
#include <stdlib.h>

#include "stack.h"

/* Modul-globale, aber nicht exportierte                          */
/* Konstanten und Variablen:                                      */
#define MAX 5

static int array [MAX];
static int topOfStack = 0;

/* Nicht exportierte, modul-globale Funktionen:                   */

/* Eine Fehlermeldung ausgeben.                                   */
/* 1. Parameter: Fehlernummer der Fehlermeldung.                  */
/* 2. Parameter: Zeilennummer, in der der Fehler auftrat.         */
static void printError (const enum stack_errors errNr, 
                        const unsigned lineNr)
{
   /* Fehlertexte passend zur enum stack_errors aus stack.h:      */
   static char * errorStrings [] = {   
      "\nOK",
      "\nStack ist voll.",
      "\nStack ist leer."
   };
   char * errString;
   if (errNr < 0 || errNr > STACK_LEER)
      errString = "Undefinierter Fehler.";
   else
      errString = errorStrings [errNr];
   fprintf (stderr, "\nFehler Nr. %d in Datei %s Zeile %d: %s",
      errNr, __FILE__, lineNr, errString);
}

/* Exportierte Funktionen:                                        */

enum stack_errors  stack_push (const int zahl)
{
   if ( topOfStack == MAX)
   {
      printError ( STACK_VOLL, __LINE__ );
      return STACK_VOLL;
   }
   else
   {
      array [topOfStack] = zahl;
      topOfStack ++;
      return STACK_OK;
   }
}

enum stack_errors  stack_pop (int * const zahl)
{
   if (topOfStack == 0)
   {
      printError ( STACK_LEER, __LINE__ );
      return STACK_LEER;
   }
   else
   {
      * zahl = array [--topOfStack];
      return STACK_OK;
   }
}

int stack_num ()
{
   return topOfStack;
}
